# -*- coding: utf-8 -*-
import ConfigParser
import os


def inifile_init(inifile):
    if not os.path.exists(inifile):
        config_raw = ConfigParser.RawConfigParser()
        # Section: Versão
        config_raw.add_section('VERSAO')
        config_raw.set('VERSAO', 'versao', '1')
        config_raw.set('VERSAO', 'data_instalacao', '1')
        # Section: Caixa
        config_raw.add_section('Caixa')
        config_raw.set('Caixa', 'user_name', 'pdvsig')
        config_raw.set('Caixa', 'password', 'pdvsig')
        # Section: Logs
        config_raw.add_section('Logs')
        config_raw.set('Logs', 'dias', '0')
        # Section: BB - Correspondente Bancário
        config_raw.add_section('BB')
        config_raw.set('BB', 'bbconvenio', '')
        config_raw.set('BB', 'bbtotalizadornfiscale', '')
        config_raw.set('BB', 'bbtotalizadornfiscalr', '')
        config_raw.set('BB', 'bbporta', 0)
        config_raw.set('BB', 'bbloja', '')
        config_raw.set('BB', 'bbagencia', '')
        config_raw.set('BB', 'bbservidor', '')
        config_raw.set('BB', 'bbfinalizdinheiro', '')
        config_raw.set('BB', 'bbfinalizcheque', '')
        # Section: PDV
        config_raw.add_section('Pdv')
        config_raw.set('Pdv', 'usarprevenda', '0')
        config_raw.set('Pdv', 'sangriadiscriminaroutros', '0')
        config_raw.set('Pdv', 'invertesinalgaveta', '0')
        config_raw.set('Pdv', 'restaurantesobalcao', 'n')
        config_raw.set('Pdv', 'usagaveta', 'False')
        config_raw.set('Pdv', 'consultaprodutos', '1')
        config_raw.set('Pdv', 'dirimportaexporta', '/usr/sig/')
        config_raw.set('Pdv', 'sangria_ticket', '')
        config_raw.set('Pdv', 'logimpressora', 'n')
        config_raw.set('Pdv', 'usardav', '0')
        config_raw.set('Pdv', 'horaminemitirz', '18:00')
        config_raw.set('Pdv', 'tamanhofontegrid', '12')
        config_raw.set('Pdv', 'conferenciadav', '0')
        config_raw.set('Pdv', 'tipofrente', 'N')
        config_raw.set('Pdv', 'restricoesclientes', '0')
        config_raw.set('Pdv', 'comandodav', 'runcobol venau001 a="D" k')
        config_raw.set('Pdv', 'nomebancocaixa', 'pdvsig')
        config_raw.set('Pdv', 'loja', '1')
        config_raw.set('Pdv', 'qtdpdvs', '1')
        config_raw.set('Pdv', 'sangria_x_z_suprimento', '0')
        config_raw.set('Pdv', 'imprimircpfcodigointerno', '0')
        config_raw.set('Pdv', 'nomeusuario', 'pdvsig')
        config_raw.set('Pdv', 'ipsupervisor', 'localhost')
        config_raw.set('Pdv', 'sangriadiscriminarcartoes', '0')
        config_raw.set('Pdv', 'sangriadiscriminartickets', '0')
        config_raw.set('Pdv', 'imprimircidade', '0')
        config_raw.set('Pdv', 'sangria_outros', '')
        config_raw.set('Pdv', 'sangriadiscriminarcheques', '0')
        config_raw.set('Pdv', 'suprimento', '')
        config_raw.set('Pdv', 'imprimirendereco', '0')
        config_raw.set('Pdv', 'itempesaveletiquetabalanca', 'False')
        config_raw.set('Pdv', 'temposupintervencao', '60')
        config_raw.set('Pdv', 'turnocommaisdeumdia', 'False')
        config_raw.set('Pdv', 'tamanhofontetotais', '18')
        config_raw.set('Pdv', 'ipcaixa', 'localhost')
        config_raw.set('Pdv', 'tamanholinha', '40')
        config_raw.set('Pdv', 'shutdownaposz', 'False')
        config_raw.set('Pdv', 'autoatende', 'False')
        config_raw.set('Pdv', 'dir_peso_itens', '')
        config_raw.set('Pdv', 'sangria_cheque', '')
        config_raw.set('Pdv', 'autorizacaosup', '0')
        config_raw.set('Pdv', 'imprimircheques', 'n')
        config_raw.set('Pdv', 'bancodedados', 'MySQL')
        config_raw.set('Pdv', 'nomebancosupervisor', 'pdvsig')
        config_raw.set('Pdv', 'sangria_dinheiro', '')
        config_raw.set('Pdv', 'caixa', '0')
        config_raw.set('Pdv', 'sangriamanual', 'False')
        config_raw.set('Pdv', 'imprimirinscricaoestadual', '0')
        config_raw.set('Pdv', 'ipretaguarda', 'localhost')
        config_raw.set('Pdv', 'senhausuario', 'pdvsig')
        config_raw.set('Pdv', 'ecftimeout', '0')
        config_raw.set('Pdv', 'sangria_cartao', '')
        config_raw.set('Pdv', 'debug', 'N')
        config_raw.set('Pdv', 'frasesangria', 'Favor efetuar sangria!')
        config_raw.set('Pdv', 'geracuponsindividuais', 'n')
        config_raw.set('Pdv', 'gavetadolegado', 'n')
        config_raw.set('Pdv', 'suprimento', 'SP')
        config_raw.set('Pdv', 'sangria_dinheiro', 'SD')
        config_raw.set('Pdv', 'sangria_cheque', 'SC')
        config_raw.set('Pdv', 'sangria_cartao', 'SC')
        config_raw.set('Pdv', 'sangria_ticket', 'ST')
        config_raw.set('Pdv', 'sangria_outros', 'SO')
        config_raw.set('Pdv', 'timeimportacao', '0')
        config_raw.set('Pdv', 'importacao_full', 'False')
        config_raw.set('Pdv', 'timeExport', '10')

        # Section: PORTAS
        config_raw.add_section('Portas')
        config_raw.set('Portas', 'fiscal_printer_active', 'True')
        config_raw.set('Portas', 'doc_scan_active', 'False')
        config_raw.set('Portas', 'itens_scan_active', 'True')
        config_raw.set('Portas', 'balanca_active', 'False')
        config_raw.set('Portas', 'balanca_active_auto', 'False')
        config_raw.set('Portas', 'scannerdoccharfim', '03')
        config_raw.set('Portas', 'scanner', '')
        config_raw.set('Portas', 'scannerdoccharinicio', '02')
        config_raw.set('Portas', 'scannerparidade', 'N')
        config_raw.set('Portas', 'scannerdocporta', '')
        config_raw.set('Portas', 'balancaporta', '')
        config_raw.set('Portas', 'balancaporta_auto', '')
        config_raw.set('Portas', 'scannerbaud', '9600')
        config_raw.set('Portas', 'balancapesomaximo', '20')
        config_raw.set('Portas', 'scannerdoctambyte', '7')
        config_raw.set('Portas', 'scannerstopbit', '1')
        config_raw.set('Portas', 'scannerdocbaud', '2400')
        config_raw.set('Portas', 'balancabaud', '2400')
        config_raw.set('Portas', 'balancabaud_auto', '2400')
        config_raw.set('Portas', 'balancatambyte', '8')
        config_raw.set('Portas', 'ecf', '1')
        config_raw.set('Portas', 'porta_cbc03', '1')
        config_raw.set('Portas', 'balancastopbit', '1')
        config_raw.set('Portas', 'scannerdocstopbit', '1')
        config_raw.set('Portas', 'balancamodelo', 'U')
        config_raw.set('Portas', 'balancaparidade', 'N')
        config_raw.set('Portas', 'scannerdocsolicitaleitura', '')
        config_raw.set('Portas', 'scannerdocparidade', 'N')
        config_raw.set('Portas', 'scannertambyte', '8')
        # Section: TEF
        config_raw.add_section('Tef')
        config_raw.set('Tef', 'empresa', '00000000')
        config_raw.set('Tef', 'tipo', 'Dedicado')
        config_raw.set('Tef', 'qtdvias', '2')
        config_raw.set('Tef', 'servidor', '')
        config_raw.set('Tef', 'digitacaocheque', 'CMC7')
        # Section: Gertec
        config_raw.add_section('Gertec')
        config_raw.set('Gertec', 'diretorio', '')
        config_raw.set('Gertec', 'utiliza', '0')
        # Section: Caixa_MySQL
        config_raw.add_section('Caixa_MySQL')
        config_raw.set('Caixa_MySQL', 'database', 'pdvsig')
        config_raw.set('Caixa_MySQL', 'hostname', 'localhost')
        config_raw.set('Caixa_MySQL', 'blobsize', '-1')
        config_raw.set('Caixa_MySQL', 'drivername', 'MySQL (Core Lab)')
        config_raw.set('Caixa_MySQL', 'errorresourcefile', '')
        config_raw.set('Caixa_MySQL', 'password', 'pdvsig')
        config_raw.set('Caixa_MySQL', 'user_name', 'pdvsig')
        config_raw.set('Caixa_MySQL', 'localecode', '0000')
        # Section: Supervisor_MySQL
        config_raw.add_section('Supervisor_MySQL')
        config_raw.set('Supervisor_MySQL', 'database', 'pdvsig')
        config_raw.set('Supervisor_MySQL', 'hostname', 'localhost')
        config_raw.set('Supervisor_MySQL', 'blobsize', '-1')
        config_raw.set('Supervisor_MySQL', 'drivername', 'MySQL (Core Lab)')
        config_raw.set('Supervisor_MySQL', 'errorresourcefile', '')
        config_raw.set('Supervisor_MySQL', 'password', 'pdvsig')
        config_raw.set('Supervisor_MySQL', 'user_name', 'pdvsig')
        config_raw.set('Supervisor_MySQL', 'localecode', '0000')
        # Section: IMAGENS
        config_raw.add_section('Imagens')
        config_raw.set('Imagens', 'local', '')
        # Section: DESCANSO DE TELA
        config_raw.add_section('DescansoTela')
        config_raw.set('DescansoTela', 'iniciar', '0')
        config_raw.set('DescansoTela', 'duracao', '0')
        # Section: BALANCA
        config_raw.add_section('Balanca')
        config_raw.set('Balanca', 'solicitaleitura', '05')
        config_raw.set('Balanca', 'charinicio', '02')
        config_raw.set('Balanca', 'codigocomdigito', 's')
        config_raw.set('Balanca', 'modelo', 'T01')
        config_raw.set('Balanca', 'digitos', '4')
        config_raw.set('Balanca', 'charfim', '03')
        # Section: TECLADO
        config_raw.add_section('Teclado')
        config_raw.set('Teclado', 'bt_cheque', '102')
        config_raw.set('Teclado', 'bt_mensagem', '120')
        config_raw.set('Teclado', 'bt_cupom', '121')
        config_raw.set('Teclado', 'mov_baixo', '118')
        config_raw.set('Teclado', 'usarcodificado', 'True')
        config_raw.set('Teclado', 'bt_desconto', '104')
        config_raw.set('Teclado', 'bt_consulta_cheque', '109')
        # config_raw.set('Teclado', 'num_.', '44')
        config_raw.set('Teclado', 'bt_cancelarnota', '70')
        config_raw.set('Teclado', 'mov_esquerda', '117')
        config_raw.set('Teclado', 'bt_socio_torcedor', '0')
        config_raw.set('Teclado', 'bt_dinheiro', '65293')
        # config_raw.set('Teclado', 'num_8', '56')
        #        config_raw.set('Teclado', 'num_9', '57')
        #        config_raw.set('Teclado', 'num_0', '48')
        #        config_raw.set('Teclado', 'num_1', '49')
        #        config_raw.set('Teclado', 'num_2', '50')
        #        config_raw.set('Teclado', 'num_3', '51')
        #        config_raw.set('Teclado', 'num_4', '52')
        #        config_raw.set('Teclado', 'num_5', '53')
        #        config_raw.set('Teclado', 'num_6', '54')
        #        config_raw.set('Teclado', 'num_7', '55')
        config_raw.set('Teclado', 'bt_entrar', '110')
        config_raw.set('Teclado', 'mov_cima', '106')
        config_raw.set('Teclado', 'bt_consulta', '105')
        config_raw.set('Teclado', 'bt_outros', '119')
        config_raw.set('Teclado', 'bt_balanca', '97')
        config_raw.set('Teclado', 'bt_quantidade', '114')
        config_raw.set('Teclado', 'bt_comanda', '99')
        config_raw.set('Teclado', 'bt_cancelar_item', '113')
        config_raw.set('Teclado', 'bt_cartao', '103')
        config_raw.set('Teclado', 'bt_cliente', '98')
        config_raw.set('Teclado', 'bt_vendedor', '0')
        config_raw.set('Teclado', 'mov_direita', '111')
        config_raw.set('Teclado', 'bt_sair', '108')
        config_raw.set('Teclado', 'bt_acrescimo', '122')
        config_raw.set('Teclado', 'bt_ticket', '112')
        config_raw.set('Teclado', 'bt_estacionamento', '130')
        config_raw.set('Teclado', 'bt_limpar', '116')
        config_raw.set('Teclado', 'bt_menu', '116')
        #Relatorio Gerencial
        config_raw.add_section('RelGerencial')
        config_raw.set('RelGerencial', 'parametro_conf', '0')
        config_raw.set('RelGerencial', 'meios_de_pegto', '0')
        config_raw.set('RelGerencial', 'identificacao_pafecf', '0')
        config_raw.set('RelGerencial', 'reletario_gerencial', '0')
        config_raw.set('RelGerencial', 'davs_emitidos', '0')
        # CONEXAO GESTAO
        config_raw.set('ConnGestao', 'server', 'localhost')
        config_raw.set('ConnGestao', 'user', 'admin')
        config_raw.set('ConnGestao', 'passwd', 'admin')
        config_raw.set('ConnGestao', 'dbname', 'dgt_new')

        # SUPRIMENTO/SANGRIA
        #        config_raw.add_section('BB')
        #        config_raw.set('BB', 'bbagencia', '')
        #        config_raw.set('BB', 'bbfinalizcheque', '')
        #        config_raw.set('BB', 'bbconvenio', '')
        #        config_raw.set('BB', 'bbfinalizdinheiro', '')
        #        config_raw.set('BB', 'bbtotalizadornfiscale', '')
        #        config_raw.set('BB', 'suprimento', '')
        #        config_raw.set('BB', 'bbtotalizadornfiscalr', '')
        #
        #        config_raw.set('BB', 'bbservidor', '')
        #        config_raw.set('BB', 'bbporta', '')
        # IMAGENS
        config_raw.set('Imagens', 'Local', '')

        with open(inifile, 'wb') as configfile:
            config_raw.write(configfile)
            res = False
    else:
        res = True
    return res
