#!/usr/bin/python
# -*- encoding: utf-8 -*-

__autor__ = 'Dener Rodrigues'

pkey_sig = """-----BEGIN RSA PRIVATE KEY-----
MIICXQIBAAKBgQDNlPEHacb00nIQ7rrZ3U4kL9QAU+vvXbLLHGR45+7zYb2cBE2s
qmnUpSgf2Jp2HL0Dz/paqxpB4pOxU6kEcDs1QOlTjt5rTsKKiw6Of7g1MsrIEQCz
tF+u8xXyl93JB0M2QBQ4PGVQQsHxyd+jdWHCOj/YpJCA/8rJUbhiVoRaQwIDAQAB
AoGBAMnIdUO3eUb4AGnKSLBq3bX7E/U2ag/KQiHGPn/F9u4Ac6FdP/hIVBQZ/2Yy
rnlb/9JsIuk3pFAi2qBk4zKuDg2V57DY+h31SLVjENZHD3M0MGonFzu1uay+s/m0
X0mMbueNXuWAAYkoAPL/wEjP/ciJkqfCUiOJADcf7PJhXfhxAkEA9F1mdw+z+GPu
tHabZ2WJJSb7JnZtAskG/spFye6UUUw53tC7mLZ7Ye3dESa3l9jtRfC4CSKbNJhX
9JyTkzcabQJBANdezxdVg4gbBbdBm6cf59aT7Y1KIrqkDtQpENBJVMXJUIa2CTEc
QvGE3UwOA37zLRFtkSZk0w1590wC7NkwWW8CQBmr+kjF0I1myjwRPdBF/Xt2tenb
hSZGwkJgM6a8Nr63uFitKxgnC51FJPVZUO5V7s9rM5paFV4YJx1ema5cmp0CQQCo
gwgqS8CEqBAK2Qy+8RnnLQt7t3wA6QipPBBpyFbKAsA9BwWeJWzDqJ+2OGjH1eF3
d3FQxybTrpCuKsPDFC+FAkALWOoMA+liEcsz/n7BardljL0BRDuqMaS2iuQ/RTAH
34xfgVdzAN8XNLA+FOAWMxyDxP1vfoa6SwUsTZsdebGa
-----END RSA PRIVATE KEY-----"""

import os
import sys
import commands
import subprocess
import traceback
import ConfigParser
from decimal import Decimal
from sigpdv.control.utils import md5_file
from exceptions import Exception
from datetime import datetime, timedelta
from sigpdv import root_path
from sigpdv.control.utils import reload_app, set_serial, get_loja as get_loja_id
from sigpdv.tools.log import traced as Log
from sigpdv.tools.config import config
from sigpdv.models.cfg_ecf_autorizada_data import CaixaCfgEcfAutorizada
from sigpdv.models.cad_finzalizadora_na_ecf_data import CaixaCadFinalizadoraNaEcf
from sigpdv.models.db_utils import exec_sql
from sigpdv.ui.dlpPwd import password_dlg
from sigpdv.ui.messagebox import YES_ROLE, MSG_ERROR, MSG_QUESTION, MSG_INFO, message_dlg
from SigUtils.crypto import verifica_assinatura, decrypt, crypt
from kiwi.python import Settable
from stoqdrivers.serialbase import SerialPort
from stoqdrivers.printers.fiscal import FiscalPrinter
from stoqdrivers.exceptions import DriverError, CommandError, \
    CouponOpenError, PendingReduceZ, HardwareFailure, \
    PrinterOfflineError, ItemAdditionError, CancelItemError, \
    PdvConnectionError, PrinterGTError, InvalidState, PrinterSerialError, \
    PrinterFileError, CommError, PaymentAdditionError, CodigoInvalido, AlreadyTotalized, \
    EcfDateError, CouponNotOpenError, OutofPaperError, TimeoutError, AlmostOutofPaper, \
    CouponNoFiscalOpenError
from uuid import getnode


class FiscalPrinterHelper(object):
    def __init__(self, parent=None, check_serial=False):
        self.parent = parent
        self.printer = self.get_printer()

    @Log
    def send_command(self, cmd, test_status_time_out=True, qtd_tentativas=30, z_pendente=False):
        if cmd.startswith(('open', 'cancel', 'summarize', 'gerencial_report_open', 'close_till',
                           'till_add_cash', 'till_remove_cash', 'till_read_memory',
                           'till_read_memory_by_reductions')):

            if z_pendente and not cmd.startswith(('cancel', 'close_till')):
                return message_dlg(self.parent, MSG_INFO,
                                   'Z Pendente. Favor Efetuar a Redução Z para efetuar '
                                   'esta operação')

        loop = 0
        while True:
            loop += 1
            try:
                ret = eval("self.printer.%s" % cmd)
                return ret
            except TimeoutError as err:
                if not test_status_time_out:
                    raise TimeoutError(str(err))
                Log.error("Erro: '%s', Comando: %s. Vou aguarda 1 segundos e tentar novamente %d"
                          % (str(err), cmd, loop))
                if loop == qtd_tentativas:
                    raise TimeoutError('Foram feitas %d tentativas, e não foi possível comunicar '
                                       'com o ECF.' % loop)
                continue

            except (CodigoInvalido, CouponNotOpenError, CancelItemError, AlreadyTotalized,
                    CouponOpenError, ItemAdditionError) as err:
                raise err

            except OutofPaperError:
                raise OutofPaperError('Impressora sem papel!')

            except CouponNoFiscalOpenError as e:
                Log.error("%s" % e)
                # cancela o cupom nao fiscal
                self.printer.cancel_last_coupon()
                coo = self.printer.get_coo()
                message_dlg(self, MSG_INFO, 'Erro: %s\n Cupom não fiscal %s cancelado.' %
                            ("%s" % e,coo))
                raise e

            except (DriverError, ValueError), err:
                if not test_status_time_out:
                    raise TimeoutError(str(err))

                if err.message == 'Dados da última RZ corrompidos':
                    msg = 'Não foi possível enviar o comando para a ECF\n\nTENTAR NOVAMENTE?'
                    if message_dlg(self.parent, MSG_QUESTION, msg, str(err.message)) != YES_ROLE:
                        return False

                elif err.message == 'Totalizador sem alíquota programada':
                    raise err

                Log.error("Erro: '%s', Comando: %s. Vou aguarda 1 segundos e tentar novamente %d"
                          % (str(err), cmd, loop))

                if loop == qtd_tentativas:
                    raise TimeoutError('Foram feitas %d tentativas, e não foi possível comunicar '
                                       'com o ECF.' % loop)
                continue

            except Exception as err:
                raise err

        return None

    @Log
    def get_printer(self):
        return False

        # todo: tirar a comunicacao com a ECF
        printer = None
        loja = config['loja']
        caixa = config['caixa']
        ecf = self.get_ecf_autorizada(loja, caixa, os.path.join(root_path, 'pdvsig.sig'), True)
        ecf_fabricante = (ecf.CFabricante or '').lower()

        if 'bematech' in ecf_fabricante:
            brand = 'bematech'
            if '4000' in ecf.CModelo:
                model = 'MP4000'
            else:
                model = 'MP2100'

        elif 'daruma' in ecf_fabricante:
            brand = 'daruma'
            model = 'FS600MFD'

        elif 'dataregis' in ecf_fabricante:
            brand = 'dataregis'
            model = 'EP375'

        elif 'elgin' in ecf_fabricante:
            brand = 'elgin'
            model = 'ELGINK'

        elif 'sweda' in ecf_fabricante:
            brand = 'sweda'
            model = 'IFS9000I'

        elif 'epson' in ecf_fabricante:
            raise Exception('ECF EPSON nao suportada')

        elif 'zpm' in ecf_fabricante:
            raise Exception('ECF ZOM nao suportada')

        elif 'urano' in ecf_fabricante:
            raise Exception('ECF URANO nao suportada')

        return False

    @Log
    def get_printer_status(self, loja, caixa, check_date=True):
        retval = self.printer.send_command(1, raw=True)
        status = self.printer.get_status(retval)
        if status.block_z:
            raise PendingReduceZ('Bloqueio por Redução Z')
        if status.open:
            raise CouponOpenError('Cupom Aberto')
        if status.off_line:
            raise PrinterOfflineError('Impressora Off-Line')
        if status.out_paper:
            raise AlmostOutofPaper("Impressora quase sem papel")
        try:
            status.check_error()
        except CommandError:
            pass

        return retval

    @Log
    def get_ecf_autorizada(self, loja, caixa, arquivo, _file=False):
        arquivo = os.path.join(root_path, arquivo)
        cmacaddress_local = (':'.join(['{:02x}'.format((getnode() >> ele) & 0xff)
                                 for ele in range(0, 8 * 6, 8)][::-1]))
        if not os.path.exists(arquivo) and _file:
            Log.info(str('[Errno 2] Arquivo de Identificação da ECF não encontrado: %s' % arquivo))
            raise PrinterGTError('Arquivo Auxiliar Nao Encontrado')

        elif not _file:
            tbl_ecf = CaixaCfgEcfAutorizada.get_by(supecf_loja=loja, supecf_caixa=caixa)
            if tbl_ecf:
                ecfs = Settable(Empresa=get_loja_id().supcfc_cliente,
                                No_Serie_Cliente='',
                                CFabricante=tbl_ecf.supecf_fabricante,
                                CModelo=tbl_ecf.supecf_modelo,
                                CVersao=tbl_ecf.supecf_versao,
                                CDataSB=tbl_ecf.supecf_data_sb,
                                CHoraSB=tbl_ecf.supecf_hora_sb,
                                CNSerie=tbl_ecf.supecf_nserie,
                                CMacAddress=cmacaddress_local,
                                CNacional=tbl_ecf.supecf_nacional,
                                md5=tbl_ecf.supecf_md5,
                                Sign=tbl_ecf.supecf_sign,
                                Check_Sign=True)
                return ecfs

        try:
            con = ConfigParser.ConfigParser()
            con.read(arquivo)
            section = '%.4d%.3d' % (loja, caixa)
            cfabricante = con.get(section, 'CFabricante')
            cmodelo = con.get(section, 'CModelo')
            cversao = con.get(section, 'CVersao')
            cdatasb = con.get(section, 'CDataSB')
            chorasb = con.get(section, 'CHoraSB')
            cnserie = con.get(section, 'CNSerie')
            cmacaddress = con.get(section, 'CMacAddress')
            cnacional = con.get(section, 'CNacional')
            md5 = con.get(section, 'md5')
            sign = con.get(section, 'Sign')
            message = '%s%s%s%s%s%s%s%s' % (cfabricante, cmodelo, cversao, cdatasb,
                                            chorasb, cnserie, cmacaddress, cnacional)

            try:
                sign_ok = verifica_assinatura(message.decode('utf-8'), sign, pkey_sig)
            except:
                raise PrinterFileError('O arquivo de configuracao do ECF foi alterado')

            if not sign_ok:
                raise PrinterFileError('O arquivo de configuracao do ECF foi alterado')

            ecfs = Settable(Empresa=con.get('Identificacao', 'Empresa').decode('utf-8'),
                            No_Serie_Cliente=con.get('Identificacao', 'No_Serie_Cliente'),
                            CFabricante=decrypt(cfabricante, pkey_sig),
                            CModelo=decrypt(cmodelo, pkey_sig),
                            CVersao=decrypt(cversao, pkey_sig),
                            CDataSB=decrypt(cdatasb, pkey_sig),
                            CHoraSB=decrypt(chorasb, pkey_sig),
                            CNSerie=decrypt(cnserie, pkey_sig),
                            CMacAddress=decrypt(cmacaddress, pkey_sig),
                            CNacional=decrypt(cnacional, pkey_sig),
                            md5=md5,
                            Sign=sign,
                            Check_Sign=sign_ok)

            #Todo: Mudar forma de controle, pelo mac não funcina 100%
            # if cmacaddress_local != ecfs.CMacAddress:
            #     raise Exception('MacAddress da máquina não cadastrado para Emitir NFC-e\n'
            #                     'loja: %d Caixa: %d \nMacAddress: %s' % (loja, caixa,
            #                                                              cmacaddress_local))

        except ConfigParser.NoSectionError:
            raise Exception('Máquina não autorizada para Emitir NFC-e'
                            'loja: %d Caixa: %d' % (loja, caixa))

        return ecfs

    @Log
    def get_ecfs_autorizadas(self):
        """
        Lê o arquivo pdvsig.sig e retorna uma lista com o Número de Série de cada ECF.

        :rtype list
        """
        retval = []

        arq = open(os.path.join(root_path, 'pdvsig.sig'), 'r')
        arq_lines = arq.readlines()
        arq.close()

        for line in arq_lines:
            try:
                if line[:8] == 'CMacAddress':
                    loja = int(arq_lines[arq_lines.index(line) - 7][1:5])
                    caixa = int(arq_lines[arq_lines.index(line) - 7][5:8])
                    ecf_autorizada = self.get_ecf_autorizada(loja, caixa, 'pdvsig.sig', True)
                    retval.append(ecf_autorizada.CNSerie)
            except:
                pass

        return retval

    @Log
    def get_data_ecf(self, mostra_msg=True):
        data = datetime.now()
        # '_date_coupon' era atualizado apenas ao abrir o frente. Quando o caixa ficava mais
        #  de um dia aberto, o cupom era gravado com data errada.
        if self.parent:
            self.parent._date_coupon = data.date()

        return data

    @Log
    def add_value_to_counter(self, _type, value, supfin_tipo_finalizadora, text=''):
        tipos = dict([
            ('D', config['sangria_dinheiro']),
            ('H', config['sangria_cheque']),
            ('C', config['sangria_cartao']),
            ('T', config['sangria_ticket']),
            ('O', config['sangria_outros'])
        ])
        nomes_f = dict([
            ('D', 'Dinheiro'),
            ('H', 'Cheque'),
            ('C', 'Cartao'),
            ('T', 'Ticket'),
            ('O', 'Outros')
        ])
        nome_f = nomes_f.get(supfin_tipo_finalizadora)
        emit_erro = False
        par_s = tipos.get(supfin_tipo_finalizadora).split(',')
        if not par_s:
            emit_erro = True
        elif len(par_s) != 2:
            emit_erro = True
        elif not par_s[0] or not par_s[1]:
            emit_erro = True
        if emit_erro:
            erro_msg = 'O Paramêtro para Sangria %s está configurado incorretamente no PDV-Config' \
                       '\n' % nome_f
            message_dlg(self.parent, MSG_ERROR, 'Não foi possível efetuar a sangria de %s' % nome_f,
                        erro_msg)
            return False

        finalizadora = CaixaCadFinalizadoraNaEcf.get_by(supfec_codigo_na_ecf=par_s[1])
        if not finalizadora:
            self.parent.show_info_proccess(False, '')
            msg = "Código %r não cadastrado na coluna 'supfec_codigo_na_ecf' " \
                  "da tabela 'cad_finalizadora_na_ecf'.\n" \
                  'Verique os parametros de Sangria no PDV-Config!' % par_s[1]
            message_dlg(self.parent, MSG_ERROR, msg)
            return False
        else:
            nome_finalizadora = nome_f
            codigo_finalizadora = finalizadora.supfec_codigo_na_ecf

        # marca_ecf = self.printer.brand
        # if marca_ecf in ['bematech', 'daruma']:
        try:
            if _type == 'SA':
                texto = 'Sangria\n%s - Valor: %s' % (nome_finalizadora, ('%.2f' % value).replace('.', ','))
                # self.send_command(
                #     "till_remove_cash(%r, text='%s')" % (value,
                #                                          nome_finalizadora.ljust(16, ' ')))
            elif _type == 'RC':
                texto = 'Recarga\n%s - Valor: %s' % (nome_finalizadora, ('%.2f' % value).replace('.', ','))
                # self.printer._add_voucher('%02d' % int(config['totalizador_recarga_cel']), value,
                #                           cod_fin=codigo_finalizadora,
                #                           text=str(nome_finalizadora.ljust(16, ' ')))
            text_cupom = self.parent.obj_cupom_fiscal.get_texto_cupom(texto)
            print '\n\n Sangria/Recarga de celular\n\n', text_cupom
            self.parent.obj_impressoras.supcci_imprimir(text_cupom)

        except (PaymentAdditionError, CommandError):
            message_dlg(self.parent, MSG_INFO,
                        'A forma de pagamento %r não está cadastrada na ECF!'
                        % nome_finalizadora)
            return False

        return True