from sigpdv import LISTA_APPS, root_path
from sigpdv.control.utils import md5_file
import os

print root_path
import compileall

compileall.compile_dir(".", force=1)

orig_files = {
    'sigfrente': os.path.join(root_path, 'pos.%s'),
    'signfe': os.path.join(root_path, 'nf', 'nf.%s'),
    'sigdav': os.path.join(root_path, 'dav_pve', 'dav.%s'),
    'pdvconfig': os.path.join(root_path, 'pdv_config.%s'),
    'sigpve': os.path.join(root_path, 'dav_pve', 'pve.%s')
}


def change_md5(file, fmd5):
    print v, fmd5
    f = open(file, 'r')
    lines = f.readlines()
    new = ''
    change = False
    for l in lines:
        if l.startswith('#MD5='):
            new += '#MD5=%s' % md5_file(fmd5)
            change = True
        else:
            new += l
    f.close()
    if change:
        f = open(file, 'w')
        f.write(new)
        f.close()
        print 'CHANCEG MD5#', file, change


for v in LISTA_APPS:
    f = orig_files.get(os.path.basename(v))
    fpy = f % 'py'
    fpyc = f % 'pyc'

    if os.path.exists(fpyc):
        change_md5(v, fpyc)
    elif os.path.exists(fpy):
        change_md5(v, fpy)

    else:
        print 'ARQUIVO NAO EXISTE'